library Path;

uses
  SysUtils,
  Windows,
  Classes,
  Controls;

{$R *.RES}

Const  Inputs   = 1;         // number of inputs
       Outputs  = 2;         // number of outputs made adjustable

       {INPUTS}
       NewPath     = 0;            // index

       {OUTPUTS}
       CurrPath    = 0;
       ProgPath    = 1;

       {USER}
       MyPath      = 2;


       DLLIndex = 100;       // fixed index of DLL No. (set by ProfiLab)

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

type TStringParams = array[0..100] of PChar;
     PStringParams = ^TStringParams;


function NumInputs: Byte;
begin
  result:=Inputs; //Define FIXED number of component input pins
end;

function NumOutputs: Byte; // Made adjustable with 'NumOutputsEx'
begin
  result:=Outputs; //Define FIXED number of component output pins
end;

{function NumInputsEx(PUser: PDLLParams): Byte; //Just in case number of inputs need to be variable
begin
  result:=...; //Define VARIABLE number of component input pins
end;}
{
function NumOutputsEx(PUser: PDLLParams): Byte;
begin
  result:= 8; //8 bit
end;
}
Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
  case Channel of
  NewPath : result:='$NewPath';
  end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
  case Channel of
  CurrPath : result:='$CurrPath';
  ProgPath : result:='$ProgPath';
  end;
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams); //called when ProfiLab enters RUN mode
begin
//
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
end;

Procedure CalculateEx(PInput,POutput,PUser: PDLLParams; PStrings: PStringParams); //called regularly from ProfiLab
var s,pfad,newpfad : string;
    i : integer;
begin
  getDir(0,s);
  if (s <> '') and (s[length(s)] <> '\') then s:= s + '\';

  if (uppercase(s) <> uppercase(PStrings[MyPath])) then
  begin
    StrPCopy(PStrings[MyPath],s);

    s:= ExtractFilePath(ParamStr(0));
    StrPCopy(PStrings[ProgPath],s);
  end;

  s:= PStrings[NewPath];
  if (s <> '') then
  begin
    if (s[length(s)] <> '\') then s:= s + '\';

    if (uppercase(s) <> uppercase(PStrings[MyPath])) then
    begin
      {$I-}
      ChDir(s);
      {$I+}
      if ioresult = 0 then StrPCopy(PStrings[MyPath],PStrings[NewPath])
      else begin //Pfad nicht vorhanden
			 newpfad:= '';
			 pfad:= s;
			 	
			 while pfad <> '' do
			 begin
		  	   i:= pos('\',pfad);
			   if i = 0 then i:= length(pfad);
			   s:= copy(pfad,1,i);
			   delete(pfad,1,i);
			   newpfad:= newpfad + s;
			   {$I-}
			   chdir(newpfad);
			   {$I+}
			   if ioresult <> 0 then
			   begin
			     mkdir(s);
			     {$I-}
			     chdir(newpfad);
			     {$I+}
			     if ioresult <> 0 then pfad:= ''; //Abbruch
			   end;
			 end; //while
			 
             if uppercase(newpfad) = uppercase(PStrings[NewPath]) then 
             begin
               StrPCopy(PStrings[MyPath],PStrings[NewPath])
			 end
			 else  StrPCopy(PStrings[MyPath],PStrings[NewPath]);
           end;
    end;
  end;
  StrPCopy(PStrings[CurrPath],PStrings[MyPath]);
end;


Procedure Configure(PUser: PDLLParams);
begin
//
end;


//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        CalculateEx,
        InputName,
        OutputName,
        Configure;
begin
end.

